Subject: Re: Request for unicore32 architecture codes to merge into linux-next

From: Paul Mundt <[email-masked]>
Date: Tue, 18 Jan 2011 18:53:10 +0900

On Tue, Jan 18, 2011 at 05:33:44PM +0800, Guan Xuetao wrote:
> > -----Original Message-----
> > From: [email-masked] [mailto:[email-masked]] On Behalf Of Paul Mundt
> > Sent: Tuesday, January 18, 2011 5:11 PM
> > To: Guan Xuetao
> > Cc: [email-masked]; 'Arnd Bergmann'; [email-masked]; [email-masked]; [email-masked]; [email-masked];
> > [email-masked]; [email-masked]; [email-masked]; [email-masked]; linux-
> > [email-masked]
> > Subject: Re: Request for unicore32 architecture codes to merge into linux-next
> > 
> > On Tue, Jan 18, 2011 at 05:07:41PM +0800, Guan Xuetao wrote:
> > > IMO, the whole architecture specific codes need to be merged first, and only some
> > > necessary drivers are included under staging. Then, I could split the staging drivers
> > > into corresponding mail-list, and then, additional drivers.
> > > Otherwise, there are no architecture basic for drivers review.
> > >
> > That's of course fine so long as the driver changes are reasonably
> > self-contained. The situation we want to avoid is that you end up with
> > drivers that depend on some private infrastructure of API where not
> > enough context is provided when the two are decoupled.
> > 
> > In any event, the architecture bits are the most self-contained and have
> > had the most review of anything in this series of patches, so it probably
> > makes sense to work on getting those bits integrated and then dealing
> > with the rest incrementally.
> Then, I should:
> 1. merge reviewed arch dir and reviewed drivers (for now, i8042)
> 2. submit staging drivers to review
> Am I right?
> 
That would at least make it easier to get parts of it merged while the
drivers get reviewed and reworked. If enough people are content with the
state of the architecture patches then there is no reason why they can't
be pulled in to -next once it's open for .39 changes. The drivers can
then gradually find their way in to -next via subsystem trees.

>>From my point of view (though I don't believe I'm a minority in this),
staging/ in general should be a last resort for new drivers. Since you
are at least actively replying and making changes that have been
requested, there should really be no need to go the staging route for
any of the drivers at all.

On the other hand, if it turns out you have a big chunk of crazed and
incomprehensible infrastructure like an interpreter or something equally
perverse in the middle somewhere that everything depends on, that does of
course complicate things and limit your options somewhat, but those sorts
of things are hopefully corner cases (I admit the fact that you're
linking libc in to the kernel has rather scared me away from reviewing
the rest of the patches under closer scrutiny). Your goal in general
should be to avoid staging completely and submit small logically isolated
components that can be reviewed and merged wholly independently of
anything else.